import string
import sys
import os
import time

from Tkinter import *

# VARIABLES

master = Tk()

master.borderwidth=10

# Processor Architecture

SIZE_MEMDATA = 64
SIZE_MEMINST = 20
SIZE_REG     = 12
MEMDATA      = []
TABINST      = []
TABLABEL     = []
TABMARK      = []
REG          = []
LIFO         = []
NUM_CYCLE    = 0
LAST_CYCLE   = -1
NUM_INST     = 0
LAST_INST    = -1
TEXT_ERROR   = ""
STATESEQ     = ""
STATEREG     = ""
STATEBUS0    = ""
STATEBUS1    = ""
STATEBUS2    = ""
STATEALU     = ""
STATEMEM     = ""
STATEIN      = ""
STATEOUT     = ""
DISPLAY_STATE = False
DISPLAY_ON   = True
INDEX_ESIN   = 0
BUFOUT       = ""
NBCYCLE      = 0

def init():
    global MEMDATA
    global REG
    global NUM_CYCLE
    global NUM_INST
    global TEXT_ERROR
    global STATESEQ
    global STATEREG
    global STATEBUS0
    global STATEBUS1
    global STATEBUS2
    global STATEALU
    global STATEMEM
    global STATEIN
    global STATEOUT
    global DISPLAY_STATE
    global DISPLAY_ON
    global INDEX_ESIN
    global BUFOUT
    global VisuOut
    global LAST_CYCLE
    global LAST_INST
    global LIFO
    global NBCYCLE

    TEXT_ERROR = " "
    STATESEQ     = ""
    STATEREG     = ""
    STATEBUS0    = ""
    STATEBUS1    = ""
    STATEBUS2    = ""
    STATEALU     = ""
    STATEMEM     = ""
    STATEIN      = ""
    STATEOUT     = ""
    DISPLAY_STATE = True
    DISPLAY_ON   = True
    INDEX_ESIN    = 0
    BUFOUT = ""
    LAST_CYCLE = -1
    LAST_INST = -1
    NBCYCLE = 0

    VisuOut.delete(ALL)
    LIFO = []
    REG = []
    for i in range(0,SIZE_REG):
        REG.append(0)
    NUM_CYCLE = 0
    NUM_INST  = 0
    MEMDATA = []
    for i in range(0,SIZE_MEMDATA):
        MEMDATA.append(0)
    exec_cycle()

def reset():
    init()
    display()

def cleanString(s):
    t=""
    i=0
    for i in range(len(s)):
        if s[i]!=" ":
            t = t+s[i]
    return t

def getESIN():
    global INDEX_ESIN
    global entry_esin
    tt = entry_esin.get()
    lt = tt.split()
    k = INDEX_ESIN % len(lt)
    return lt[k]

def exec_save():
    global entry_file
    global TABINST
    global TABLABL
    global TEXT_ERROR
    name = entry_file.get()
    if name == "":
        TEXT_ERROR="SAVE ERROR : no name given"
        display()
        return
    save(name)
    return

def save(name):
    global TABINST
    global TABLABL
    global TEXT_ERROR
    f = open(name,"w")
    for i in range(len(TABINST)):
        t = ""
        s = cleanString(TABLABEL[i].get())
        if len(s) !=0 :
            t = t+s+": "
        f.write(t)
        for j in range(15-len(t)):
            f.write(" ")
        f.write(TABINST[i].get()+"\n")
    f.close();
    return

def exec_load():
    global entry_file
    global TABINST
    global TABLABL
    global TEXT_ERROR

    svgd="SVGD_"+time.strftime('%d_%m_%y_%H:%M',time.localtime())
    save(svgd)

    name = entry_file.get()
    if name == "":
        TEXT_ERROR="LOAD ERROR : no name given"
        display()
        return

    for i in range(len(TABINST)):
        TABLABEL[i].delete(0,END)
        TABINST[i].delete(0,END)

    try:
        f = open(name,"r")
    except IOError as e:
        TEXT_ERROR="LOAD ERROR : cannot find "+name
        display()
        return

    l = f.readlines()

    for i in range(len(l)):
        ll = l[i].split()
        if len(ll)>0:
            s = ll[0]
            j = 0
            if s[len(s)-1] == ':':
                TABLABEL[i].insert(0,s[:-1])
                j=1
            t=""
            for h in range(j,len(ll)):
                t = t+ll[h]+" "
            TABINST[i].insert(0,t)
            if i==SIZE_MEMINST:
                break

    f.close()
    init()
    display()
    return

def check_reg(reg):
    if len(reg)<2:
        return False
    if reg[0]!= 'R':
        return False
    for i in range(1,len(reg)):
        if reg[i] < '0' or reg[i] > '9':
            return False
    x = int(reg[1:])
    if x >= SIZE_REG:
        return False
    return True

def check_int(s):
    if s[0]=='-' or (s[0] >= '0' and s[0]<='9'):
        for i in range(1,len(s)):
            if s[i] < '0' or s[i] > '9':
                return False
        return True
    else:
        return False

def xtr_int(s):
    return int(s)

def xtr_reg(reg):
    return int(reg[1:])

def next_cycle():
    global DISPLAY_ON
    global NB_CYCLE
    state = exec_cycle()
    if DISPLAY_ON:
        display()
    return state

def exec_inst():
    global entry_nb_inst
    global DISPLAY_ON
    global DISPLAY_STATE
    k = int(entry_nb_inst.get())
    i = 0
    ok = True
    DISPLAY_ON = False
    while NUM_CYCLE != 0:
        exec_cycle()
    while i < k and ok:
        j=0
        while j < 4 and ok:
            ok = exec_cycle()
            j=j+1
        i=i+1
    DISPLAY_ON = True
    DISPLAY_STATE = False
    display()
    DISPLAY_STATE = True
    return

def exec_cycle():
    global TABINST
    global NUM_INST
    global NUM_CYCLE
    global STATESEQ
    global TEXT_ERROR
    global DISPLAY_ON
    global STATEREG
    global STATEBUS0
    global STATEBUS1
    global STATEBUS2
    global STATEALU
    global STATEMEM
    global STATEIN
    global STATEOUT
    global INDEX_ESIN
    global VisuOut
    global BUFOUT
    global LAST_INST
    global LAST_CYCLE
    global LIFO
    global REG
    global MEMDATA
    global NBCYCLE

    TEXT_ERROR = ""
    STATESEQ  = ""
    STATEREG  = ""
    STATEBUS0 = ""
    STATEBUS1 = ""
    STATEBUS2 = ""
    STATEALU  = ""
    STATEMEM = ""
    STATEIN = ""
    STATEOUT = ""

    if NUM_CYCLE == 0:
        NBCYCLE = NBCYCLE + 1

    if NUM_INST >= SIZE_MEMINST:
        TEXT_ERROR = "Program Counter Overflow"
        return False

    inst = TABINST[NUM_INST].get()

    # ----- cycle 0

    if NUM_CYCLE ==0 :

        if len(inst)==0:
            TEXT_ERROR = "No instruction to execute"
            return False
        STATESEQ = "Decode "+inst
        linst = inst.split()

        # - OP R1 R2 R3

        if linst[0] == "ADD" or linst[0] == "SUB" or linst[0] == "AND" or linst[0] == "OR" or linst[0] == "XOR":
            if len(linst) != 4:
                TEXT_ERROR = "Syntax error : line "+str(NUM_INST)
                return False
            if not (check_reg(linst[1]) and check_reg(linst[2]) and check_reg(linst[3])):
                TEXT_ERROR = "Syntax error : line "+str(NUM_INST)
                return False;

        # - OP R1 integer

        elif linst[0] == "MOV" :
            if len(linst) != 3:
                TEXT_ERROR = "Syntax error : line "+str(NUM_INST)
                return False
            if not (check_reg(linst[1]) and check_int(linst[2])):
                TEXT_ERROR = "Syntax error : line "+str(NUM_INST)
                return False;

        # - OP label

        elif linst[0] == "JMP" or linst[0] == "CALL":
            if len(linst) != 2:
                TEXT_ERROR = "Syntax error : line "+str(NUM_INST)
                return False
            ok = False
            for i in range(0,len(TABLABEL)):
                if cleanString(TABLABEL[i].get()) == linst[1]:
                    ok = True
                    break
            if ok == False:
                TEXT_ERROR = "Wrong label : line "+str(NUM_INST)
                return False

        # - OP

        elif linst[0] == "RET" or linst[0] == "NOP":
            if len(linst) != 1:
                TEXT_ERROR = "Syntax error : line "+str(NUM_INST)
                return False


        # OP R1 label

        elif linst[0] == "JZ" or linst[0] == "JNZ" or linst[0] == "JSUP" or linst[0] == "JINF":
            if len(linst) != 3:
                TEXT_ERROR = "Syntax error : line "+str(NUM_INST)
                return False
            if check_reg(linst[1]) == False:
                TEXT_ERROR = "Syntax error : line "+str(NUM_INST)
                return False
            ok = False
            for i in range(0,len(TABLABEL)):
                if cleanString(TABLABEL[i].get()) == linst[2]:
                    ok = True
                    break
            if ok == False:
                TEXT_ERROR = "Wrong label  : line "+str(NUM_INST)
                return False

        # - OP R1 R2

        elif linst[0] == "ST" or linst[0] == "LD":
            if len(linst) != 3:
                TEXT_ERROR = "Syntax error : line "+str(NUM_INST)
                return False
            if not(check_reg(linst[1]) and check_reg(linst[2])):
                TEXT_ERROR = "Syntax error : line "+str(NUM_INST)
                return False

        # - OP R1

        elif linst[0] == "IN" or linst[0] == "OUT":
            if len(linst) != 2:
                TEXT_ERROR = "Syntax error : line "+str(NUM_INST)
                return False
            if check_reg(linst[1]) == False:
                TEXT_ERROR = "Syntax error : line "+str(NUM_INST)
                return False
            

        else:
            TEXT_ERROR = "No such instruction : : line "+str(NUM_INST)
            return False

        LAST_CYCLE = 0
        NUM_CYCLE = 1
        return True

    # ----- cycle 1

    if NUM_CYCLE == 1:
        linst = inst.split()

        if linst[0] == "ADD" or linst[0] == "SUB" or linst[0] == "AND" or linst[0] == "OR" or linst[0] == "XOR":
            STATEREG = "READ R["+str(xtr_reg(linst[2]))+"] and R["+str(xtr_reg(linst[3]))+"]"
            STATEBUS0 = str(REG[xtr_reg(linst[2])])
            STATEBUS1 = str(REG[xtr_reg(linst[3])])

        if linst[0] == "JZ" or linst[0] == "JNZ" or linst[0] == "JSUP" or linst[0] == "JINF":
            STATEREG = "READ R["+str(xtr_reg(linst[1]))+"]"
            STATEBUS0 = str(REG[xtr_reg(linst[1])])

        if linst[0] == "ST":
            STATEREG = "READ R["+str(xtr_reg(linst[1]))+"] and R["+str(xtr_reg(linst[2]))+"]"
            STATEBUS0 = str(REG[xtr_reg(linst[1])])
            STATEBUS1 = str(REG[xtr_reg(linst[2])])

        if linst[0] == "OUT":
            STATEREG = "READ R["+str(xtr_reg(linst[1]))+"]"
            STATEBUS0 = str(REG[xtr_reg(linst[1])])

        if linst[0] == "LD":
            STATEREG = "READ R["+str(xtr_reg(linst[2]))+"]"
            STATEBUS1 = str(REG[xtr_reg(linst[2])])

        LAST_CYCLE = 1
        NUM_CYCLE = 2
        return True

    # ----- cycle 2

    if NUM_CYCLE == 2:
        linst = inst.split()

        if linst[0] == "ADD" or linst[0] == "SUB" or linst[0] == "AND" or linst[0] == "OR" or linst[0] == "XOR":
            STATEBUS0 = str(REG[xtr_reg(linst[2])])
            STATEBUS1 = str(REG[xtr_reg(linst[3])])
            if linst[0] == "ADD":
                r = REG[xtr_reg(linst[2])] + REG[xtr_reg(linst[3])]
                STATEBUS2 = str(r)
                STATEALU  = "Compute  "+STATEBUS0+" + "+STATEBUS1+" = "+str(r)
            if linst[0] == "SUB":
                r = REG[xtr_reg(linst[2])] - REG[xtr_reg(linst[3])]
                STATEBUS2 = str(r)
                STATEALU  = "Compute  "+STATEBUS0+" - "+STATEBUS1+" = "+str(r)
            if linst[0] == "AND":
                r = REG[xtr_reg(linst[2])] and REG[xtr_reg(linst[3])]
                STATEBUS2 = str(r)
                STATEALU  = "Compute  "+STATEBUS0+" and "+STATEBUS1+" = "+str(r)
            if linst[0] == "OR":
                r = REG[xtr_reg(linst[2])] or REG[xtr_reg(linst[3])]
                STATEBUS2 = str(r)
                STATEALU  = "Compute  "+STATEBUS0+" or "+STATEBUS1+" = "+str(r)
            if linst[0] == "XOR":
                r = REG[xtr_reg(linst[2])] ^ REG[xtr_reg(linst[3])]
                STATEBUS2 = str(r)
                STATEALU  = "Compute  "+STATEBUS0+" xor "+STATEBUS1+" = "+str(r)

        if linst[0] == "MOV":
            STATESEQ = "Send "+str(xtr_int(linst[2]))            
            STATEBUS2 = str(xtr_int(linst[2]))            

        if linst[0] == "JZ" or linst[0] == "JNZ" or linst[0] == "JSUP" or linst[0] == "JINF":
            STATEBUS0 = str(REG[xtr_reg(linst[1])])
            STATEALU  = "Compute  "+STATEBUS0+" + 0 = "+STATEBUS0

        if linst[0] == "ST":
            STATEBUS0 = str(REG[xtr_reg(linst[1])])
            STATEBUS1 = str(REG[xtr_reg(linst[2])])
            STATEMEM  = "Write: MEM["+STATEBUS0+"]="+STATEBUS1
            MEMDATA[REG[xtr_reg(linst[1])]] = REG[xtr_reg(linst[2])]

        if linst[0] == "OUT":
            STATEBUS0 = str(REG[xtr_reg(linst[1])])
            STATEOUT = "OUT DATA"
            BUFOUT = STATEBUS0+" "+BUFOUT
            VisuOut.delete(ALL)
            if len(BUFOUT) < 100:
                VisuOut.create_text(10,20,text=BUFOUT,anchor="w",font=('calibri',14));
            else:
                VisuOut.create_text(10,20,text=BUFOUT[0:100],anchor="w",font=('calibri',14));

        if linst[0] == "LD":
            STATEBUS2 = str(MEMDATA[REG[xtr_reg(linst[2])]])
            STATEBUS1 = str(REG[xtr_reg(linst[2])])
            STATEMEM  = "Read: MEM["+STATEBUS1+"] -->"+STATEBUS2
            
        if linst[0] == "IN":
            STATEBUS2 = getESIN()
            STATEIN = "IN DATA"

        LAST_CYCLE = 2
        NUM_CYCLE = 3
        return True

    # ----- cycle 3

    if NUM_CYCLE == 3:
        STATESEQ = "Compute next address"
        linst = inst.split()
        if linst[0] == "ADD" or linst[0] == "SUB" or linst[0] == "AND" or linst[0] == "OR" or linst[0] == "XOR":
            if linst[0] == "ADD":
                r = REG[xtr_reg(linst[2])] + REG[xtr_reg(linst[3])]
                STATEBUS2 = str(r)
                REG[xtr_reg(linst[1])] = r
            if linst[0] == "SUB":
                r = REG[xtr_reg(linst[2])] - REG[xtr_reg(linst[3])]
                STATEBUS2 = str(r)
                REG[xtr_reg(linst[1])] = r
            if linst[0] == "AND":
                r = REG[xtr_reg(linst[2])] and REG[xtr_reg(linst[3])]
                STATEBUS2 = str(r)
                REG[xtr_reg(linst[1])] = r
            if linst[0] == "OR":
                r = REG[xtr_reg(linst[2])] or REG[xtr_reg(linst[3])]
                STATEBUS2 = str(r)
                REG[xtr_reg(linst[1])] = r
            if linst[0] == "XOR":
                r = REG[xtr_reg(linst[2])] ^ REG[xtr_reg(linst[3])]
                STATEBUS2 = str(r)
                REG[xtr_reg(linst[1])] = r
            STATEREG = "WRITE R["+str(xtr_reg(linst[1]))+"]"
            LAST_INST = NUM_INST
            NUM_INST = NUM_INST+1

        if linst[0] == "LD":
            r = MEMDATA[REG[xtr_reg(linst[2])]]
            STATEBUS2 = str(r)
            REG[xtr_reg(linst[1])] = r
            STATEREG = "WRITE R["+str(xtr_reg(linst[1]))+"]"
            LAST_INST = NUM_INST
            NUM_INST = NUM_INST+1
            
        if linst[0] == "IN":
            r = int(getESIN())
            STATEBUS2 = str(r)
            REG[xtr_reg(linst[1])] = r
            STATEREG = "WRITE R["+str(xtr_reg(linst[1]))+"]"
            LAST_INST = NUM_INST
            NUM_INST = NUM_INST+1
            INDEX_ESIN = INDEX_ESIN + 1

        if linst[0] == "MOV":
            STATEBUS2 = str(xtr_int(linst[2]))            
            STATEREG = "WRITE R["+str(xtr_reg(linst[1]))+"]"
            REG[xtr_reg(linst[1])] = xtr_int(linst[2])
            LAST_INST = NUM_INST
            NUM_INST = NUM_INST+1

        if linst[0] == "JMP":
            i = 0
            while cleanString(TABLABEL[i].get()) != linst[1]:
                i=i+1
            LAST_INST = NUM_INST
            NUM_INST = i;

        if linst[0] == "CALL":
            i = 0
            while cleanString(TABLABEL[i].get()) != linst[1]:
                i=i+1
            LAST_INST = NUM_INST
            LIFO.append(NUM_INST+1)
            NUM_INST = i;

        if linst[0] == "RET":
            NUM_INST = LIFO[len(LIFO)-1]
            LIFO = LIFO[:-1]

        if linst[0] == "JZ" or linst[0] == "JNZ" or linst[0] == "JSUP" or linst[0] == "JINF":
            i = 0
            while cleanString(TABLABEL[i].get()) != linst[2]:
                i=i+1
            r = REG[xtr_reg(linst[1])]
            if linst[0] == "JZ":
                if r == 0:
                    LAST_INST = NUM_INST
                    NUM_INST = i
                else:
                    LAST_INST = NUM_INST
                    NUM_INST = NUM_INST+1
            if linst[0] == "JNZ":
                if r != 0:
                    LAST_INST = NUM_INST
                    NUM_INST = i
                else:
                    LAST_INST = NUM_INST
                    NUM_INST = NUM_INST+1
            if linst[0] == "JSUP":
                if r > 0:
                    LAST_INST = NUM_INST
                    NUM_INST = i
                else:
                    LAST_INST = NUM_INST
                    NUM_INST = NUM_INST+1
            if linst[0] == "JINF":
                if r < 0:
                    LAST_INST = NUM_INST
                    NUM_INST = i
                else:
                    LAST_INST = NUM_INST
                    NUM_INST = NUM_INST+1

        if linst[0] == "ST":
            LAST_INST = NUM_INST
            NUM_INST = NUM_INST+1

        if linst[0] == "OUT":
            LAST_INST = NUM_INST
            NUM_INST = NUM_INST+1

        if linst[0] == "NOP":
            LAST_INST = NUM_INST
            NUM_INST = NUM_INST+1

        LAST_CYCLE = 3
        NUM_CYCLE = 0
        return True

    return 



def display():
    global SeqRegAlu
    global MemData
    global NUM_CYCLE
    global DISPLAY_STAT
    global TABMARK
    global NUM_INST
    global TABINST
    global LAST_INST
    global LAST_CYCLE
    global STATEREG
    global STATEMEM
    global STATESEQ
    global STATEBUS0
    global STATEBUS1
    global STATEBUS2
    global STATEIN
    global STATEOUT
    global NBCYCLE

    MemData.delete(ALL)
    SeqRegAlu.delete(ALL)
    for i in range(len(TABMARK)):
        TABMARK[i].delete(ALL)

    if len(TEXT_ERROR)!=0:
        SeqRegAlu.create_text(580,30,text=TEXT_ERROR,font=('colibri',12),anchor="e",fill="red")
        LAST_INST = NUM_INST

    if LAST_CYCLE >=0:
        SeqRegAlu.create_text(20,30,text="# CYCLE "+str(LAST_CYCLE),font=('colibri',12),anchor="w",fill="#228B22")
        SeqRegAlu.create_text(100,30,text="# INST "+str(NBCYCLE),font=('colibri',12),anchor="w",fill="#228B22")
        if LAST_CYCLE == 3:
            SeqRegAlu.create_text(200,30,text=TABINST[LAST_INST].get(),font=('colibri',12),anchor="w",fill="blue")
            TABMARK[LAST_INST].create_line(0,10,25,10,arrow="last", width=4,fill="red")
        else:
            SeqRegAlu.create_text(200,30,text=TABINST[NUM_INST].get(),font=('colibri',12),anchor="w",fill="blue")
            TABMARK[NUM_INST].create_line(0,10,25,10,arrow="last", width=4,fill="red")


    # ----- Bus

    if len(STATEBUS0)!=0:
        SeqRegAlu.create_line(75,490,575,490,width=16,fill="#669999")
    else:
        SeqRegAlu.create_line(75,490,575,490,width=16,fill="#999999")

    if len(STATEBUS1)!=0:
        SeqRegAlu.create_line(75,520,575,520,width=16,fill="#999966")
    else:
        SeqRegAlu.create_line(75,520,575,520,width=16,fill="#999999")

    if len(STATEBUS2)!=0:
        SeqRegAlu.create_line(75,550,575,550,width=16,fill="#996699")
    else:
        SeqRegAlu.create_line(75,550,575,550,width=16,fill="#999999")


    # ----- Data Memory

    for i in range(SIZE_MEMDATA):
        MemData.create_text(30,20+i*19,text=str(i),anchor="e", font=('colibri',10))
        MemData.create_text(35,20+i*19,text=": "+str(MEMDATA[i]),anchor="w", font=('colibri',10),fill="blue")
        
    if len(STATEBUS0)!=0 and len(STATEMEM)!=0:
        SeqRegAlu.create_line(580,490,630,490,width=16,arrow="last", fill="#669999")
    else:
        SeqRegAlu.create_line(580,490,630,490,width=16,arrow="last", fill="#333333")
        
    if len(STATEBUS1)!=0 and len(STATEMEM)!=0:
        SeqRegAlu.create_line(580,520,630,520,width=16,arrow="last", fill="#999966")
    else:
        SeqRegAlu.create_line(580,520,630,520,width=16,arrow="last", fill="#333333")

    if len(STATEBUS2)!=0 and len(STATEMEM)!=0:
        SeqRegAlu.create_line(580,550,630,550,width=16,arrow="first", fill="#996699")
    else:
        SeqRegAlu.create_line(580,550,630,550,width=16,arrow="first", fill="#333333")

    # ----- Cadre
    SeqRegAlu.create_rectangle(10,10,640,600)

    # ----- Sequencer
    SeqRegAlu.create_rectangle(225,70,425,170,fill="#dddddd")
    SeqRegAlu.create_text(235,80, text="Sequencer", anchor="w", font=("colibri",12))
    if LAST_CYCLE == 0:
        SeqRegAlu.create_line(20,95,215,95, arrow="last", width=15, fill="#997799")
    else:
        SeqRegAlu.create_line(20,95,215,95, arrow="last", width=15, fill="#999999")
    if LAST_CYCLE == 3:
        SeqRegAlu.create_line(20,145,215,145, arrow="first", width=15, fill="#997799")
        SeqRegAlu.create_text(200,120, text=str(NUM_INST), anchor="w", font=("colibri",12),fill="red")
    else:
        SeqRegAlu.create_line(20,145,215,145, arrow="first", width=15, fill="#999999")


    # ----- SP LiFo

    SeqRegAlu.create_rectangle(475,90,575,150,fill="#dddddd")
    SeqRegAlu.create_line(430,105,465,105, arrow="last")
    SeqRegAlu.create_line(430,135,465,135, arrow="first")
    t = ""
    for i in range(len(LIFO)):
        t = str(LIFO[i])+"  "+t
    SeqRegAlu.create_text(485,120,text=t,anchor="w")

    # ----- Register
    SeqRegAlu.create_rectangle(75,250,275,450,fill="#dddddd")
    SeqRegAlu.create_text(85,260, text="Registers", anchor="w", font=("colibri",12))

    if len(STATEBUS0)!=0 and len(STATEREG)!=0:
        SeqRegAlu.create_line(115,450,115,482, arrow="last", width=16, fill="#669999")
    else:
        SeqRegAlu.create_line(115,450,115,482, arrow="last", width=16)

    if len(STATEBUS1)!=0 and len(STATEREG)!=0:
        SeqRegAlu.create_line(175,450,175,512, arrow="last", width=16, fill="#999966")
    else:
        SeqRegAlu.create_line(175,450,175,512, arrow="last", width=16)

    if len(STATEBUS2)!=0 and len(STATEREG)!=0:
        SeqRegAlu.create_line(235,450,235,542, arrow="first", width=16, fill="#996699")
    else:
        SeqRegAlu.create_line(235,450,235,542, arrow="first", width=16)


    for i in range(SIZE_REG/2):
        SeqRegAlu.create_text(105,290+i*20,text=str(i),anchor="e",font=('colibri',10))
        SeqRegAlu.create_text(110,290+i*20,text=":  "+str(REG[i]),anchor="w",font=('colibri',10),fill="blue")
        SeqRegAlu.create_text(185,290+i*20,text=str(i+SIZE_REG/2),anchor="e",font=('colibri',10))
        SeqRegAlu.create_text(200,290+i*20,text=" :  "+str(REG[i+SIZE_REG/2]),anchor="w",font=('colibri',10),fill="blue")

    # ------ ALU
    SeqRegAlu.create_rectangle(375,250,575,450,fill="#dddddd")
    SeqRegAlu.create_text(385,260, text="Arithmetic & Logic Unit", anchor="w", font=("colibri",12))

    if len(STATEBUS0)!=0 and len(STATEALU)!=0:
        SeqRegAlu.create_line(415,450,415,482, arrow="first", width=16,fill="#669999")
    else:
        SeqRegAlu.create_line(415,450,415,482, arrow="first", width=16)

    if len(STATEBUS1)!=0 and len(STATEALU)!=0:
        SeqRegAlu.create_line(475,450,475,512, arrow="first", width=16,fill="#999966")
    else:
        SeqRegAlu.create_line(475,450,475,512, arrow="first", width=16)

    if len(STATEBUS2)!=0 and len(STATEALU)!=0:
        SeqRegAlu.create_line(535,450,535,542, arrow="last",  width=16, fill="#996699")
    else:
        SeqRegAlu.create_line(535,450,535,542, arrow="last",  width=16)

    if len(STATEALU)!=0:
        SeqRegAlu.create_line(400,250,400,170, arrow="last", width=2, fill="blue")
    else:
        SeqRegAlu.create_line(400,250,400,170, arrow="last", width=2)

    # ----- IN
    if len(STATEBUS2)!=0 and len(STATEIN)!=0:
        SeqRegAlu.create_line(20,550,50,550,width=16,arrow="last", fill="#996699")
    else:
        SeqRegAlu.create_line(20,550,50,550,width=16,arrow="last", fill="#333333")

    # ----- OUT
    if len(STATEBUS0)!=0 and len(STATEOUT)!=0:
        SeqRegAlu.create_line(20,490,50,490, arrow="first", width=16,fill="#669999")
    else:
        SeqRegAlu.create_line(20,490,50,490, arrow="first", width=16)

    if DISPLAY_STATE:
        SeqRegAlu.create_text(175,430,text=STATEREG,font=('colibri',10),fill="blue")
        SeqRegAlu.create_text(475,430,text=STATEALU,font=('colibri',10),fill="blue")
        SeqRegAlu.create_text(325,120, text=STATESEQ, font=("colibri",12),fill="blue")
        SeqRegAlu.create_text(65,490,text=STATEBUS0,anchor="e",fill="blue",font=('calibri',12))
        SeqRegAlu.create_text(65,550,text=STATEBUS2,anchor="e",fill="blue",font=('calibri',12))
        SeqRegAlu.create_text(65,520,text=STATEBUS1,anchor="e",fill="blue",font=('calibri',12))
        #MemData.create_text(75,650,text=STATEMEM,fill="blue",font=('calibri',12))
        if len(STATEREG) != 0:
            SeqRegAlu.create_line(225,180,175,240,arrow="last",width=2,fill="blue")
        if len(STATEALU) != 0:
            SeqRegAlu.create_line(425,180,475,240,arrow="last",width=2,fill="blue")
        if len(STATEMEM) != 0:
            SeqRegAlu.create_line(435,80,635,80,arrow="last",width=2,fill="blue")
        if len(STATESEQ) !=0:
            if STATESEQ[0:4]=="Send":
                SeqRegAlu.create_line(325,180,325,542,arrow="last",width=2,fill="blue")

# ---------------------------------------------------------------------------------------------- GENERAL DISPLAY

Frame_EMPTYH     = Frame(master, borderwidth=0)
Frame_EMPTYV     = Frame(master, borderwidth=0)
Frame_CTRLBOARD  = LabelFrame(master, borderwidth=3, text= " Control Board ")
Frame_SEQREGALU  = Frame(master, borderwidth=3)
Frame_MEMINST    = LabelFrame(master, borderwidth=3, text= " Instruction Memory ")
Frame_MEMDATA    = LabelFrame(master, borderwidth=3, text= " Data Memory ")
Frame_ESIN       = LabelFrame(master, borderwidth=3, text= " Data IN ")
Frame_ESOUT      = LabelFrame(master, borderwidth=3, text= " Data OUT ")

# --------------------------------------------------------------------------------------------- LAYOUT

#          0          1          2          3          4         5
#
#    0   EMPTYH
#    1             MEMINST   ---- CTRL BOARD ----    MEMDATA
#    2             MEMINST   ---- SEQREGALU  ----    MEMDATA
#    3              ESOUT    ---- SEQREGALU  ----    MEMDATA
#    4              ESIN     ---- SEQREGALU  ----    MEMDATA
#    5                                                         EMPTYV

Frame_EMPTYH.grid(row=0, column=0)
Frame_EMPTYV.grid(row=5, column=5)
Frame_CTRLBOARD.grid(row=1, column=2, columnspan=2)
Frame_SEQREGALU.grid(row=2 ,column=2, rowspan=3, columnspan=2)
Frame_MEMINST.grid(row=1,column=1,rowspan=2)
Frame_MEMDATA.grid(row=1,column=4,rowspan=4)
Frame_ESIN.grid(row=4,column=1)
Frame_ESOUT.grid(row=3,column=1)

Canvas(Frame_EMPTYH, width=10, height=10).grid(row=0, column=0)
Canvas(Frame_EMPTYV, width=10, height=10).grid(row=0, column=0)

# --------------------------------------------------------------------------------------------- CONTROL BOARD

Canvas(Frame_CTRLBOARD, width=1, height=10).grid(row=10,column=0)
Label (Frame_CTRLBOARD, text=" ").grid(row=20, column=0)
Button(Frame_CTRLBOARD, text="RESET", fg="blue", width=5, command=reset).grid(row=20,column=30)
Label (Frame_CTRLBOARD, text=" ").grid(row=20,column=40)
Button(Frame_CTRLBOARD, text="NEXT CYCLE", fg="blue", width=9, command=next_cycle).grid(row=20,column=50)
Label (Frame_CTRLBOARD, text=" ").grid(row=20,column=55)
Button(Frame_CTRLBOARD, text="NEXT INST", fg="blue", width=8, command=exec_inst).grid(row=20,column=60)
Label (Frame_CTRLBOARD, text=" ").grid(row=20,column=70)
entry_nb_inst = Entry (Frame_CTRLBOARD, width=4)
entry_nb_inst.grid(row=20,column=80)
entry_nb_inst.insert(0,"1")
Label (Frame_CTRLBOARD, text="  ").grid(row=20,column=85)
Button(Frame_CTRLBOARD, text="SAVE", fg="blue", width=6, command=exec_save).grid(row=20,column=90)
Label (Frame_CTRLBOARD, text=" ").grid(row=20,column=95)
Button(Frame_CTRLBOARD, text="LOAD", fg="blue", width=6, command=exec_load).grid(row=20,column=97)
Label (Frame_CTRLBOARD, text=" ").grid(row=20,column=100)
entry_file = Entry (Frame_CTRLBOARD, width=10)
entry_file.grid(row=20,column=110)
Label (Frame_CTRLBOARD, text=" ").grid(row=20,column=120)
Canvas(Frame_CTRLBOARD, width=1, height=10).grid(row=30,column=0)

# -------------------------------------------------------------------------------------------- INSTRUCTION MEMORY

MemInst = Canvas(Frame_MEMINST,width=10, height=10)
MemInst.grid(row=0,column=0)
for i in range(0,SIZE_MEMINST):
    TABMARK.append(Canvas(Frame_MEMINST,width=25,height=10))
    TABMARK[len(TABMARK)-1].grid(row=i+1,column=0)
    Label (Frame_MEMINST, text=str(i), width=4, font=("colibri",10)).grid(row=i+1,column=1)
    TABLABEL.append(Entry(Frame_MEMINST, width=6, font=("colibri",10)))
    TABLABEL[len(TABLABEL)-1].grid(row=i+1,column=2)
    TABINST.append(Entry(Frame_MEMINST, width=20, font=("colibri",10)))
    TABINST[len(TABINST)-1].grid(row=i+1,column=3)
Canvas(Frame_MEMINST,width=10,height=10).grid(row=30,column=4)

# -------------------------------------------------------------------------------------------- SEQ REG ALU


SeqRegAlu = Canvas(Frame_SEQREGALU, width=645, height=600)
SeqRegAlu.grid(row=0,column=0)

# -------------------------------------------------------------------------------------------- DATA MEMORY

ysbdm = Scrollbar(Frame_MEMDATA, orient=VERTICAL)
ysbdm.grid(row=0, column=1, sticky=N+S)
MemData = Canvas(Frame_MEMDATA, width=110, height=650, scrollregion=(0,0,100,1250), yscrollcommand=ysbdm.set)
MemData.grid(row=0,column=0, sticky=N)
ysbdm.config(command=MemData.yview)

# -------------------------------------------------------------------------------------------- IN

Canvas(Frame_ESIN,width=10, height=10).grid(row=0,column=0)
Label(Frame_ESIN,text = "  ").grid(row=1,column=0)
entry_esin = Entry (Frame_ESIN, width=27)
entry_esin.grid(row=1,column=1)
Label(Frame_ESIN,text = "  ").grid(row=1,column=2)
entry_esin.insert(0,"1 2 3 4 5")
Canvas(Frame_ESIN,width=10,height=10).grid(row=2,column=0)

# -------------------------------------------------------------------------------------------- OUT

VisuOut = Canvas(Frame_ESOUT,width=250, height=40)
VisuOut.grid(row=0,column=0)

init()

reset()
master.title('Micro Processor Simulator - D. Lavenier')
master.mainloop()
